/*----------------------------------------------+
| free							Florian Hufsky	|
|												|
| free.h										|
| start 2.6.2003								|
+----------------------------------------------*/
/*--------------------------------------------------------------+
| free															|
|																|
| a multi platform game programming library using SDL / glSDL.	|
| the main goal is to create an as easy to use as possible		|
| library for all kind of 2d games.								|
|																|
|																|
| todo:															|
|																|
|	+ das Programm strtzt ab, wenn etwas gezeichnet werden soll|
|	  und kein freeMain objekt initialisiert worden ist, bzw	|
|	  bei der initialisierung ein fehler aufgetreten ist.		|
+--------------------------------------------------------------*/

#ifndef __FREE_H__
#define __FREE_H__


#ifdef WIN32
#include <SDL.h>
#include <SDL_image.h>
#else
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <string.h>
#endif


#include "sfont/SFont.h"

#include "clog/clog.h"
#include "csound/csound.h"



class freeMain{
	public:
		freeMain();
		~freeMain();

		bool init(int screenwidth, int screenheight, bool fullscreen, const char *logfile);
		bool flip(){return SDL_Flip(screen) == 0 ? true : false;};

		//bool UpdateMessages();
		Uint8 pressed(int key){return keystates[key];};

		void msg(int level, char *s, ...);
		CLog *getLog(){return &log;}; //ext

		SDL_Surface *getScreen(){return screen;};

	private:
		SDL_Surface	*screen;
		SDL_Event	m_event;
		Uint8		*keystates;
		CLog		log;
};



class freeSprite{
	public:
		freeSprite();
		~freeSprite();

		bool init(const char *filename, Uint32 transparentcolor);
		bool init(const char *filename);
		bool draw(int x, int y);


		int getWidth(){return m_picture->w;};
		int getHeight(){return m_picture->h;};

	private:
		SDL_Surface *m_picture;
		SDL_Rect m_bltrect;
};



class freeAnimSprite{
	public:
		freeAnimSprite();
		~freeAnimSprite();

		bool init(const char *filename, Uint32 transparentcolor, int picwidth, int picheight, Uint32 delay);
		bool draw(int x, int y);
		bool draw(int x, int y, int PicNum);

		int getWidth(){return m_picrect.w;};
		int getHeight(){return m_picrect.h;};
		unsigned int getPC(){return (unsigned int)m_anzbilder;}; //by Z-Man

	private:
		SDL_Surface *m_picture;
		SDL_Rect m_bltrect;
		SDL_Rect m_picrect;

		int *m_xoffsets;
		int *m_yoffsets;

		Uint32 m_lastpicswitch;
		Uint32 m_delay;
		int m_aktbild;
		int m_anzbilder;
};



class freeFont{
	public:
		freeFont();
		~freeFont();

		bool init(const char *filename);
		bool draw(int x, int y, char *s);
		bool drawf(int x, int y, char *s, ...);
		int	 GetCharWidth(char c);
		int  GetStringWidth(char *s);

	private:
		SFont_FontInfo m_font;
};


#endif


//last changes: tijot 0.89.3 - no_skill

