/****************************************/
/*			RDHighscore.h				*/
/*	A simple Highscore wrapper, contains*/
/*  XOR Cryption. Saved values are		*/
/*  Name								*/
/*	Points								*/
/*	Level								*/
/*	Time								*/
/*  This class is developed under the   */
/*  terms of the gnu-gpl !              */
/****************************************/
/*			www.RedDesert.de			*/
/****************************************/
/*	Project start:			13.09.03	*/
/*	Project last changes:	22.09.03	*/ 
/****************************************/
/*	ToDo:								*/
/*		-Nothing						*/
/****************************************/
#ifndef RDHIGHSCORE
#define RDHIGHSCORE



#define RDHIGHSCORE_IDSTRING	"RedDesertHighscore" //Programm ID string, kann angepasst werden
#define RDHIGHSCORE_VERSION		0			//Versonsnummer der Klasse
#define RDHIGHSCORE_ERROR		0			//Return Wert bei errors in Add und Check
#define RDHIGHSCORE_SIZE_ID		20			//Maximale lnge des ID strings in Zeichen
#define RDHIGHSCORE_SIZE_NAME	20			//Maximale lnge der Spielernamen in Zeichen


//Includes
#include <stdio.h>
#include <time.h>
#include <string.h>

//Struct & Class Predefines
struct RDHighscoreHeader;
struct RDHighscoreEntry;
class  RDHighscore;

//Struct Defines

typedef struct RDHighscoreHeader{
	char		chIDString[RDHIGHSCORE_SIZE_ID];//ID String des Programms (muss als define gesetzt werden)
	unsigned char uchVersion;					//Version der Highscore Klasse
	unsigned int uiElements;					//Anzahl der im file gespeicherten Elemente
	time_t		tCreate;						//Timestamp der erstellungszeit
	time_t		tChange;						//Timestamp der letzten nderung
}RDHighscoreHeader;


typedef struct RDHighscoreEntry{
	char		chName[RDHIGHSCORE_SIZE_NAME];	//Name des Spielers
	long int	liPoints;						//Anzahl der erreichten punkte
	long int	liLevel;						//Erreichtes Level
	long int	liTime;							//Spieldauer in Sekunden
	time_t		tCreate;						//Timestamp der erstellungszeit

	RDHighscoreEntry	*pNext;					//Pointer auf nchstes Element (fr Linked List)
}RDHighscoreEntry;

//Class defines

class RDHighscore{
private:
	RDHighscoreHeader	*pHead;
	RDHighscoreEntry	*pEntry;

	bool	Crypt(void *pTarget,void *pSource,unsigned int uiSize,char chCode[]);
	bool	Compare(RDHighscoreEntry *pFirst,RDHighscoreEntry *pSecond);
	void	Sort(void);
public:
	RDHighscore(void);
	~RDHighscore(void);

	/*File functions*/
	bool	LoadFile(char chPath[],char chHeaderCode[]);
	bool	WriteFile(char chPath[],char chHeaderCode[]);
	bool	ResetFile(char chPath[],char chHeaderCode[]);

	RDHighscoreHeader *GetHeader(void);
	
	/*Highscore functions*/
	unsigned char	Cut(unsigned int uiCut);
	unsigned char	Add(RDHighscoreEntry HighscoreEntry);
	unsigned char	Check(RDHighscoreEntry *pHighscoreEntry);
	unsigned char	GetCount(void);
	RDHighscoreEntry *Get(unsigned char uchPlace);
	void			Reset(void);
};





//Additional Help functions

RDHighscoreEntry	RDHighscoreCreate(char chName[RDHIGHSCORE_SIZE_NAME],long int liPoints,long int liLevel,long int liTime);

#endif

/****************************************/
/*		By RedDesert (z-man) 2003C		*/
/*		  Please visit our page:		*/
/*			www.RedDesert.de			*/
/****************************************/

//last changes: tijot 0.89.3 - zman
