/****************************************/
/*				RDMen.cpp				*/
/*	This is a simple menue engine for   */
/*	the RedDesert tetris project (tijot)*/
/*  this source is published under the  */
/*	terms of the GNU GPL! I would be    */
/*	pleased to get some feedback if you */
/*	use this source! Please also visit  */
/*  our hompage.						*/
/****************************************/
/*			www.RedDesert.de			*/
/****************************************/
/*	Project start:			04.01.04	*/
/*	Project last change:	12.01.04	*/
/****************************************/
/*	ToDo:								*/
/*		-Perhaps add other features*g*	*/
/*	DoNe:								*/
/*		-Finish Label class				*/
/*		-Finish Button class			*/
/*		-Finish Keyboard class			*/
/*		-Finish Mouse class				*/
/*		-Finish Input class				*/
/****************************************/


//Includes
#include "RDMen.h"

//RDMenMouse

RDMenMouse::RDMenMouse(void) {
	this->State		=0;
	this->PosX		=0;
	this->PosY		=0;
	this->iOld		=true;
};//RDMenMouse::RDMenMouse(void)


RDMenMouse::~RDMenMouse(void) {
	this->State		=0;
	this->PosX		=0;
	this->PosY		=0;
	this->iOld		=true;
};//RDMenMouse::~RDMenMouse(void)


bool	RDMenMouse::Init(char chGrf[]) {
	if(!this->Grf.init(chGrf,0xff00ff)) return false;
	this->State		=0;
	this->PosX		=0;
	this->PosY		=0;
	this->iOld=SDL_ShowCursor(false);
	return true;
};//bool	RDMenMouse::Init(char chGrf[])


void	RDMenMouse::Reset(void) {
	this->State		=0;
	this->PosX		=0;
	this->PosY		=0;
	SDL_ShowCursor(this->iOld);
	this->iOld		=true;
	return;
};//void	RDMenMouse::Reset(void)


bool	RDMenMouse::Run(void) {
	int		VirtState=RDMEN_KLICKNOTHING;
	VirtState=SDL_GetMouseState(&this->PosX,&this->PosY);
	this->State=RDMEN_KLICKNOTHING;

	if(SDL_BUTTON(SDL_BUTTON_LEFT) & VirtState) this->State|=RDMEN_KLICKLEFT;
	if(SDL_BUTTON(SDL_BUTTON_RIGHT)& VirtState) this->State|=RDMEN_KLICKRIGHT;

	return true;
};//bool	RDMenMouse::Run(void) 


bool	RDMenMouse::Draw(void) {
	return this->Grf.draw(this->PosX,this->PosY);
};//bool	RDMenMouse::Draw(void)


void	RDMenMouse::GetState(int *pX,int *pY,int *pS){
	(*pX)=this->PosX;
	(*pY)=this->PosY;
	(*pS)=this->State;
	return;
};//void	RDMenMouse::GetState(int *pX,int *pY,int *pS)


//RDMenKeyboard

RDMenKeyboard::RDMenKeyboard(void) {
	this->iKey=0;
	return;
};//RDMenKeyboard::RDMenKeyboard(void)


RDMenKeyboard::~RDMenKeyboard(void) {
	this->iKey=0;
	return;
};//RDMenKeyboard::RDmenKeyboard(void)


bool	RDMenKeyboard::Init(void) {
	this->PrevState=SDL_EnableUNICODE(true);
	this->iKey=0;
	return true;
};//bool	RDMenKeyboard::Init(void) 


bool	RDMenKeyboard::Run(void) {
	this->iKey=0;
	//Update MSG
	while(SDL_PollEvent(&this->event)) {
		if(this->event.type==SDL_QUIT) return false;
		else if(this->event.type==SDL_KEYDOWN) {
			this->iKey=this->event.key.keysym.unicode;
		}
		/*else if(this->event-type==SDL_KEYUP) { //not used yet

		}*/
	}

	return true;
};


void	RDMenKeyboard::GetState(int *iKey) {
	(*iKey)=this->iKey;
	return;
};//void	RDMenKeyboard::GetState(int *iKey)


void	RDMenKeyboard::Reset(void) {
	SDL_EnableUNICODE(this->PrevState);
	this->iKey=0;
	return;
};//void	RDMenKeyboard::Reset(void)


//RDMenButton

RDMenButton::RDMenButton(void){
	this->bfntPressed	=false;
	this->bfntSelected	=false;
	this->bfntStandart	=false;
	this->bgrfPressed	=false;
	this->bgrfSelected	=false;
	this->bgrfStandart	=false;
	this->bsndPressed	=false;
	this->bsndSelected	=false;
	this->pPosmX		=NULL;
	this->pPosmY		=NULL;
	this->pStatem		=NULL;
	this->chText		=NULL;
	this->iState		=RDMEN_NOTINIT;
	return;
};//RDMenButton::RDMenButton(void)


RDMenButton::~RDMenButton(void) {
	this->bfntPressed	=false;
	this->bfntSelected	=false;
	this->bfntStandart	=false;
	this->bgrfPressed	=false;
	this->bgrfSelected	=false;
	this->bgrfStandart	=false;
	this->bsndPressed	=false;
	this->bsndSelected	=false;
	this->pPosmX		=NULL;
	this->pPosmY		=NULL;
	this->pStatem		=NULL;
	if(this->chText!=NULL) {
		delete [] chText;
		this->chText		=NULL;
	}
};//RDMenButton::~RDMenButton(void)


bool	RDMenButton::Init(SDL_Rect BoundRect) {
	this->Reset();
	memcpy(&this->BoundRect,&BoundRect,sizeof(SDL_Rect));
	this->iState		=RDMEN_STANDART;
	return true;
};//bool	RDMenButton::Init(SDL_Rect BoundRect)


void	RDMenButton::Reset(void) {
	this->bfntPressed	=false;
	this->bfntSelected	=false;
	this->bfntStandart	=false;
	this->bgrfPressed	=false;
	this->bgrfSelected	=false;
	this->bgrfStandart	=false;
	this->bsndPressed	=false;
	this->bsndSelected	=false;
	this->pPosmX		=NULL;
	this->pPosmY		=NULL;
	this->pStatem		=NULL;
	if(this->chText!=NULL) {
		delete [] chText;
		this->chText		=NULL;
	}
	return;
};//void	RDMenButton::Reset(void)


bool	RDMenButton::ActFntPressed(char chPath[]) {
	if(!this->fntPressed.init(chPath)) return false;
	this->bfntPressed=true;
	return true;
};//bool	RDMenButton::ActFntPressed(char chPath[])


bool	RDMenButton::ActFntSelected(char chPath[]) {
	if(!this->fntSelected.init(chPath)) return false;
	this->bfntSelected=true;
	return true;
};//bool	RDMenButton::ActFntSelected(char chPath[])


bool	RDMenButton::ActFntStandart(char chPath[]) {
	if(!this->fntStandart.init(chPath)) return false;
	this->bfntStandart=true;
	return true;
};//bool	RDMenButton::ActFntStandart(char chPath[])


bool	RDMenButton::ActGrfPressed(char chPath[]) {
	if(!this->grfPressed.init(chPath,RDMEN_CC)) return false;
	this->bgrfPressed=true;
	return true;
};//bool	RDMenButton::ActGrfPressed(char chPath[]) 


bool	RDMenButton::ActGrfSelected(char chPath[]) {
	if(!this->grfSelected.init(chPath,RDMEN_CC)) return false;
	this->bgrfSelected=true;
	return true;
};//bool	RDMenButton::ActGrfSelected(char chPath[])


bool	RDMenButton::ActGrfStandart(char chPath[]) {
	if(!this->grfStandart.init(chPath,RDMEN_CC)) return false;
	this->bgrfStandart=true;
	return true;
};//bool	RDMenButton::ActGrfStandart(char chPath[])


bool	RDMenButton::ActMouse(int *pPosmX,int *pPosmY,int *pStatem) {
	this->pPosmX	=pPosmX;
	this->pPosmY	=pPosmY;
	this->pStatem	=pStatem;
	return true;
};//bool	RDMenButton::ActMouse(int *pPosmX,int *pPosmY,int *pStatem)


bool	RDMenButton::ActSndSelected(char chPath[]) {
	if(!this->sndSelected.Load(chPath)) return false;
	this->bsndSelected=true;
	return true;
};//bool	RDMenButton::ActSndSelected(char chPath[])


bool	RDMenButton::ActSndPressed(char chPath[]) {
	if(!this->sndPressed.Load(chPath)) return false;
	this->bsndPressed=true;
	return true;
};//bool	RDMenButton::ActSndPressed(char chPath[])


bool	RDMenButton::ActText(char chText[]) {
	if(this->chText!=NULL) {
		delete [] this->chText;
		this->chText=NULL;
	}
	this->chText=new char[strlen(chText)+1];

	if(this->chText==NULL) return false;
	sprintf(this->chText,"%s",chText);

	return true;
};//bool	RDMenButton::ActText(char chText[])


SDL_Rect	RDMenButton::GetRect(void) {
	return this->BoundRect;
};//SDL_Rect	RDMenButton::GetRect(void)


void		RDMenButton::SetRect(SDL_Rect BoundRect) {
	memcpy(&this->BoundRect,&BoundRect,sizeof(SDL_Rect));
	return;
};//void		RDMenButton::SetRect(SDL_Rect BoundRect)


int			RDMenButton::GetState(void) {
	return this->iState;
};//int			RDMenButton::GetState(void)


void		RDMenButton::SetState(int NewState) {
	this->iState=NewState;
	return;
};//void		RDMenButton::SetState(int NewState) 


bool		RDMenButton::Run(void) {
	if(this->iState==RDMEN_NOTINIT) return false;

	if(this->pPosmX==NULL || this->pPosmY==NULL || this->pStatem==NULL) return false;

	if(this->BoundRect.x<(*this->pPosmX) && (this->BoundRect.x+this->BoundRect.w)>(*this->pPosmX) &&
		this->BoundRect.y<(*this->pPosmY) && (this->BoundRect.y+this->BoundRect.h)>(*this->pPosmY)) {
		if((*this->pStatem) & RDMEN_KLICKLEFT) {
			if(this->iState!=RDMEN_PRESSED && this->bsndPressed) {
				if(!this->sndPressed.Play()) return false;
			}
			this->iState=RDMEN_PRESSED;
		}
		else {
			if(this->iState!=RDMEN_SELECTED && this->bsndSelected) {
				if(!this->sndSelected.Play()) return false;
			}
			this->iState=RDMEN_SELECTED;
		}
	}
	else {
		this->iState=RDMEN_STANDART;
	}

	return true;
};//bool		RDMenButton::Run(void)


bool		RDMenButton::Draw(void) {
	if(this->iState==RDMEN_STANDART) {
		if(this->bgrfStandart) {
			if(!this->grfStandart.draw(this->BoundRect.x,this->BoundRect.y)) return false;
		}


		if(this->bfntStandart && this->chText!=NULL) {
			if(!this->fntStandart.draw(this->BoundRect.x,this->BoundRect.y,this->chText)) return false;
		}
	}
	else if(this->iState==RDMEN_SELECTED) {
		if(this->bgrfSelected) {
			if(!this->grfSelected.draw(this->BoundRect.x,this->BoundRect.y)) return false;
		}
		else if(this->bgrfStandart) {
			if(!this->grfStandart.draw(this->BoundRect.x,this->BoundRect.y)) return false;
		}

		if(this->bfntSelected &&this->chText!=NULL) {
			if(!this->fntSelected.draw(this->BoundRect.x,this->BoundRect.y,this->chText)) return false;
		}
		else if(this->bfntStandart &&this->chText!=NULL) {
			if(!this->fntStandart.draw(this->BoundRect.x,this->BoundRect.y,this->chText)) return false;
		}
	}
	else if(this->iState==RDMEN_PRESSED) {
		if(this->bgrfPressed) {
			if(!this->grfPressed.draw(this->BoundRect.x,this->BoundRect.y)) return false;
		}
		else if(this->bgrfSelected) {
			if(!this->grfSelected.draw(this->BoundRect.x,this->BoundRect.y)) return false;
		}
		else if(this->bgrfStandart) {
			if(!this->grfStandart.draw(this->BoundRect.x,this->BoundRect.y)) return false;
		}

		if(this->bfntPressed &&this->chText!=NULL) {
			if(!this->fntPressed.draw(this->BoundRect.x,this->BoundRect.y,this->chText)) return false;
		}
		else if(this->bfntSelected &&this->chText!=NULL) {
			if(!this->fntSelected.draw(this->BoundRect.x,this->BoundRect.y,this->chText)) return false;
		}		
		else if(this->bfntStandart &&this->chText!=NULL) {
			if(!this->fntStandart.draw(this->BoundRect.x,this->BoundRect.y,this->chText)) return false;
		}		
	}
	else return false;

	return true;
};//bool		RDMenButton::Draw(void)


//RDMenLabel

RDMenLabel::RDMenLabel(void) {
	this->bfntStandart	=false;
	this->bgrfStandart	=false;
	this->chText		=NULL;
	return;
};//RDMenLabel::RDMenLabel(void)


RDMenLabel::~RDMenLabel(void) {
	this->bfntStandart	=false;
	this->bgrfStandart	=false;
	if(this->chText!=NULL) {
		delete [] this->chText;
		this->chText=NULL;
	}
	return;
};//RDMenLabel::~RDMenLabel(void)


bool	RDMenLabel::Init(SDL_Rect BoundRect) {
	this->Reset();
	memcpy(&this->BoundRect,&BoundRect,sizeof(SDL_Rect));
	return true;
};//bool	RDMenLabel::Init(SDL_Rect BoundRect)


void	RDMenLabel::Reset(void) {
//	this->bfntStandart	=false;
	this->bgrfStandart	=false;
	if(this->chText!=NULL) {
		delete [] this->chText;
		this->chText=NULL;
	}
	return;
};//void	RDMenLabel::Reset(void)


bool	RDMenLabel::ActFntStandart(char chFnt[],char chText[]) {
	if(!this->fntStandart.init(chFnt)) return false;
	if(this->chText!=NULL) {
		delete [] this->chText;
		this->chText=NULL;
	}
	this->chText=new char[strlen(chText)+1];
	if(this->chText==NULL) return false;

	sprintf(this->chText,"%s",chText);
	this->bfntStandart=true;
	return true;
};//bool	RDMenLabel::ActFntStandart(char chFnt[],char chText[])


bool	RDMenLabel::ActGrfStandart(char chGrf[]) {
	if(!this->grfStandart.init(chGrf,RDMEN_CC)) return false;
	this->bgrfStandart=true;
	return true;
};//bool	RDMenLabel::ActGrfStandart(char chGrf[])


bool	RDMenLabel::Draw(void) {
	if(this->bgrfStandart) {
		if(!this->grfStandart.draw(this->BoundRect.x,this->BoundRect.y)) return false;
	}
	if(this->bfntStandart && this->chText!=NULL) {
		if(!this->fntStandart.draw(this->BoundRect.x,this->BoundRect.y,this->chText)) return false;
	}
	return true;
};//bool	RDMenLabel::Draw(void)


//RDMemInput
	
RDMenInput::RDMenInput(void) {
	this->bgrfStandart	=false;
	this->chText		=NULL;
	this->iK			=NULL;
	this->iState		=RDMEN_NOTINIT;
	this->pAutoPress	=NULL;
	this->pPosmX		=NULL;
	this->pPosmY		=NULL;
	this->pStatem		=NULL;
	this->uiCursor		=0;
	this->uiMaxText		=0;
	this->uiBlinkTimer	=0;
	this->bBlink		=true;
	return;
};//RDMenInput::RDMenInput(void)


RDMenInput::~RDMenInput(void) {
	this->bgrfStandart	=false;
	if(this->chText!=NULL) {
		delete [] this->chText;
		this->chText		=NULL;
	}
	this->iK			=NULL;
	this->iState		=RDMEN_NOTINIT;
	this->pAutoPress	=NULL;
	this->pPosmX		=NULL;
	this->pPosmY		=NULL;
	this->pStatem		=NULL;
	this->uiCursor		=0;
	this->uiMaxText		=0;
	this->uiBlinkTimer	=0;
	this->bBlink		=true;
	return;
};//RDMenInput::~RDMenInput(void)


bool RDMenInput::Init(SDL_Rect BoundRect,unsigned int uiMaxText,char chCursor[],char chFont[]) {
	this->Reset();
	if(!this->grfCursor.init(chCursor,0xff00ff)) return false;
	if(!this->Font.init(chFont)) return false;

	this->uiMaxText	=uiMaxText;
	this->chText=new char[uiMaxText+1];
	if(this->chText==NULL) return false;
	this->chText[0]='\0';

	memcpy(&this->BoundRect,&BoundRect,sizeof(SDL_Rect));

	this->iState	=RDMEN_STANDART;

	return true;
};//bool RDMenInput::Init(SDL_Rect BoundRect,unsigned int uiMaxText,char chCursor[],char chFont[])


void	RDMenInput::Reset(void) {
	this->bgrfStandart	=false;
	if(this->chText!=NULL) {
		delete [] this->chText;
		this->chText		=NULL;
	}
	this->iK			=NULL;
	this->iState		=RDMEN_NOTINIT;
	this->pAutoPress	=NULL;
	this->pPosmX		=NULL;
	this->pPosmY		=NULL;
	this->pStatem		=NULL;
	this->uiCursor		=0;
	this->uiMaxText		=0;
	this->uiBlinkTimer	=0;
	this->bBlink		=true;
	return;
};//void	RDMenInput::Reset(void) 


bool	RDMenInput::ActGrfStandart(char chPath[]) {
	if(!this->grfStandart.init(chPath,RDMEN_CC)) return false;
	this->bgrfStandart=true;
	return true;
};//bool	RDMenInput::ActGrfStandart(char chPath[])


bool	RDMenInput::ActKeyboard(int *iK) {
	this->iK=iK;
	return true;
};//bool	RDMenInput::ActKeyboard(int *iK)


bool	RDMenInput::ActMouse(int *pPosmX,int *pPosmY,int *pStatem) {
	this->pPosmX	=pPosmX;
	this->pPosmY	=pPosmY;
	this->pStatem	=pStatem;
	return true;
};//bool	RDMenInput::ActMouse(int *pPosmX,int *pPosmY,int *pStatem)


SDL_Rect	RDMenInput::GetRect(void) {
	return this->BoundRect;
};//SDL_Rect	RDMenInput::GetRect(void)


void	RDMenInput::SetRect(SDL_Rect BoundRect) {
	memcpy(&this->BoundRect,&BoundRect,sizeof(SDL_Rect));
	return;
};//void	RDMenInput::SetRect(SDL_Rect BoundRect)


bool	RDMenInput::GetText(char pTarget[]) {
	if(this->chText==NULL || pTarget==NULL) return false;

	sprintf(pTarget,"%s",this->chText);
	return true;
};//bool	RDMenInput::GetText(char pTarget[])


int		RDMenInput::GetState(void) {
	return this->iState;
};//int		RDMenInput::GetState(void)


bool	RDMenInput::SetAutoPress(RDMenButton *pPress) {
	this->pAutoPress=pPress;
	return true;
};//bool	RDMenInput::SetAutoPress(RDMenButton *pPress)


void	RDMenInput::SetState(int NewState) {
	this->iState=NewState;
	return;
};//void	RDMenInput::SetState(int NewState)


bool		RDMenInput::SetText(char chText[]) {
	if(this->chText==NULL || strlen(chText)>this->uiMaxText) return false;
	sprintf(this->chText,"%s",chText);
	this->uiCursor=strlen(this->chText);
	return true;
};//bool	RDMenInput::SetText(char chText)


bool	RDMenInput::Run(void) {
	int		Adder=0;



	if(this->iState==RDMEN_NOTINIT) return false;
	if(this->pPosmX!=NULL && this->pPosmY!=NULL && this->pStatem!=NULL) { //maus aktiv
		if((*this->pStatem) & RDMEN_KLICKLEFT) {
			if(this->BoundRect.x<(*this->pPosmX) && (this->BoundRect.x+this->BoundRect.w)>(*this->pPosmX) &&	//Innerhalb des brects
				this->BoundRect.y<(*this->pPosmY) && (this->BoundRect.y+this->BoundRect.h)>(*this->pPosmY)) {
				this->uiCursor=strlen(this->chText);
				this->iState=RDMEN_SELECTED;
			}
			else {
				this->iState=RDMEN_STANDART;
			}

		}
	}
	else {	//keine Maus--> Auto selected
		this->iState=RDMEN_SELECTED;
	}

	if(this->iState==RDMEN_SELECTED) { //Nur dann input
		//Keyboard input verarbeiten
		if((*this->iK)==SDLK_ESCAPE) {	//Sonderevents verarbeiten
			this->iState=RDMEN_STANDART;
			return true;
		}
		else if((*this->iK)==SDLK_RETURN) {
			this->iState=RDMEN_PRESSED;
			if(this->pAutoPress!=NULL) {
				this->pAutoPress->SetState(RDMEN_PRESSED);
			}
			return true;
		}
		else if((*this->iK)==SDLK_SPACE) {
			if(this->uiCursor<this->uiMaxText) {
				this->chText[this->uiCursor]=' ';
				this->uiCursor++;
				this->chText[this->uiCursor]='\0';
			}
			//Alles vom cursor an 1 nach rechts
			}
		else if((((*this->iK)>31||(*this->iK)=='\b')) && ((*this->iK)<128)) {
			if(((*this->iK)=='\b')&& this->uiCursor>0) {
				this->uiCursor--;
				this->chText[this->uiCursor]='\0';
			}
			else if((*this->iK)!='\b' && this->uiCursor<this->uiMaxText) {
				this->chText[this->uiCursor]=(*this->iK);
				this->uiCursor++;
				this->chText[this->uiCursor]='\0';
			}
		}

	}
	return true;
};//bool	RDMenInput::Run(void)


bool	RDMenInput::Draw(void) {
	int		DrawCX=0;
	unsigned int			i=0;
	if(this->iState==RDMEN_NOTINIT) return false;

	if(this->bgrfStandart) {
		if(!this->grfStandart.draw(this->BoundRect.x,this->BoundRect.y)) return false;
	}
	//Draw Text
	if(!this->Font.draw(this->BoundRect.x,this->BoundRect.y,this->chText)) return false;

	if(this->iState==RDMEN_SELECTED) {
		//Blinkeffekt muss noch rein*g*
		for(i=0;i<this->uiCursor;i++) {
			DrawCX+=this->Font.GetCharWidth(this->chText[i]);
		}
		if(SDL_GetTicks()-this->uiBlinkTimer>RDMEN_BLINKDELAY) {
			this->uiBlinkTimer=SDL_GetTicks();
			if(this->bBlink) this->bBlink=false;
			else this->bBlink=true;
		}

		if(this->bBlink) {
			if(!this->grfCursor.draw(DrawCX+this->BoundRect.x,this->BoundRect.y)) return false;
		}
	}


	return true;
};//bool	RDMenInput::Draw(void)


//Zusatzfunktionen
SDL_Rect	RDMenCreateRect(int x,int y,int w,int h) {
	SDL_Rect	r;
	r.x	=x;
	r.y	=y;
	r.w	=w;
	r.h	=h;
	return r;
};

/****************************************/
/*		By RedDesert (z-man) 2004C		*/
/*		  Please visit our page:		*/
/*			www.RedDesert.de			*/
/****************************************/

