/****************************************/
/*				RDSecurity.cpp			*/
/* A simple hash algo to check if		*/
/* anybody changed you files.			*/
/*This is freeware,you may redistribute	*/
/* this source at your will!			*/
/* But please send us a mail at		    */
/* info@reddesert.de or post in our     */
/* board at www.reddesert.de!!			*/
/****************************************/
/*			www.RedDesert.de			*/
/****************************************/
/*	Project start:			25.08.03	*/
/*	Project Status:				00%		*/
/*	Project finish:			--.--.--	*/
/****************************************/
/*	ToDo:								*/
/*		-Use MD5 Hash algorhytme		*/
/****************************************/
#include "RDSecurity.h"

unsigned int	RDSCreateHash(char chPath[]){
	unsigned int Ret=0;
	FILE	*pFile=NULL;
	int iInp=0;
	pFile=fopen(chPath,"rb");
	if(pFile==NULL) return 0;
	while(iInp!=EOF) {
		iInp=fgetc(pFile);
		for(int i=0;i<=sizeof(int);i++) {
			if(iInp & (0x01 << i)) Ret++;
		}
	}
	fclose(pFile);
	return Ret;
}

	
bool		RDSCompare(unsigned int cmpHash,char chPath[]){
	if(cmpHash!=RDSCreateHash(chPath)) return false;
	return true;
}

bool		RDSCompare(char chPath[],char chPath2[]){
	if(RDSCreateHash(chPath)!=RDSCreateHash(chPath2)) return false;
	return true;
}



bool		RDSCheckList(char chPath[]) {
	FILE	*pFile=NULL;
	char	Tmp[50];
	char	preTmp[50];
	unsigned int		iTmp=0;

	sprintf(Tmp,"%s%s",chPath,RDSS_FILE);
	pFile	=fopen(Tmp,"r");
	if(pFile==NULL) return false;

	if(fscanf(pFile,"%s\n",Tmp)==EOF) {
		fclose(pFile);
		return false;
	}
	if(strcmp(Tmp,RDSS_HEADERSEC)!=0) {
		fclose(pFile);
		return false;
	}
	if(fscanf(pFile,"%s %u\n",preTmp,&iTmp)==EOF) {
		fclose(pFile);
		return false;
	}
	if(strcmp(preTmp,RDSS_SEC)!=0) {
		fclose(pFile);
		return false;
	}
	if(RDSCreateHash(chPath)!=iTmp) {
		fclose(pFile);
		return false;
	}
	pFile	=fopen(chPath,"r");
	if(pFile==NULL) return false;

	if(fscanf(pFile,"%s\n",Tmp)==EOF) {
		fclose(pFile);
		return false;
	}
	if(strcmp(Tmp,RDSS_HEADER)!=0) {
		fclose(pFile);
		return false;
	}
	while(fscanf(pFile,"%s %s %u\n",preTmp,Tmp,&iTmp)!=EOF) {
		if(strcmp(preTmp,RDSS_CMP)!=0) continue;
		if(!RDSCompare(iTmp,Tmp)) {
			fclose(pFile);
			return false;
		}
	}
	fclose(pFile);
	return true;;
}


FILE		*RDSListOPEN(char chPath[]){
	FILE	*pFile;
	pFile=fopen(chPath,"w");
	if(pFile==NULL) return NULL;

	fprintf(pFile,"%s\n",RDSS_HEADER);
	return pFile;
}


void		RDSListADD(char chTmp[],FILE *pFile){
	if(pFile==NULL) return;
	fprintf(pFile,"%s %s %u\n",RDSS_CMP,chTmp,RDSCreateHash(chTmp));
	return;
}

void		RDSListCLOSE(FILE *pFile,char chOrg[]){
	char	Tmp[100];
	fclose(pFile);
	pFile=NULL;
	sprintf(Tmp,"%s%s",chOrg,RDSS_FILE);
	pFile=fopen(Tmp,"w");
	if(pFile==NULL) return;
	fprintf(pFile,"%s\n",RDSS_HEADERSEC);
	fprintf(pFile,"%s %u\n",RDSS_SEC,RDSCreateHash(chOrg));
	fclose(pFile);
	pFile=NULL;
	return;
}
